type 'a export_channel = out_channel * 'a option;;

let open_export f = 
  let ec = (open_out_bin f, None : $a export_channel) in
  export_value (fst ec) (snd ec);
  ec
;;

let close_export ec = close_out (fst ec);;

let export (ec :'a export_channel) (v : 'a) = output_value (fst ec) v;;

type 'a import_channel = in_channel * 'a option;;

let open_import f = 
  let ic = (open_in f, None : $a import_channel) in
  (import_value (fst ic) : $a option);
  ic
;;

let close_import ic = close_in (fst ic);;

let import (ic :'a import_channel) = (input_value (fst ic) : 'a);;

(*
let ec = open_export "hello" in 
export ec (1,1); 
export ec (2,3); 
close_export ec;;

let ic = open_import "hello" in 
(import ic  : int * int);; 
*)
